import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A 'Body' is any kind of object in space that has a mass. It could be a star, or a planet, 
 * or anything else that floats around in space.
 * 
 * @author Michael Kolling 
 * @version 0.1
 */
public class Rocket extends SmoothMover
{   
    public Rocket() {
        this(new Vector(0, 15.0)); //call constructor in this class that takes
                                   // a Vector as a parameter
    }
    
    /**
     * Construct a Rocket with a specified movement.
     */
    public Rocket(Vector movement)
    {
        addForce(movement);
    }
    
    /**
     * Act. That is: move.
     */
    public void act() 
    {
        move();
        checkForEdges();
        checkForBarrels();
        randomTurn();
    }
    
    private void randomTurn() {
        if(Greenfoot.getRandomNumber(100) < 10) {
            setRotation(getRotation()-10);
            Vector v = getMovement();
            v.setDirection(getRotation());
        }
    }
    
    private void checkForEdges() {
        if(getX() < 50 || getX() > getWorld().getWidth() - 50) {
            setRotation(getRotation()+15);
            Vector v = getMovement();
            v.setDirection(getRotation());
           // move();
        }
        if(getY() < 50 || getY() > getWorld().getHeight() - 50) {
            setRotation(getRotation()+15);
            Vector v = getMovement();
            v.setDirection(getRotation());
            //move();
        }
    }
    
    private void checkForBarrels() {
        Actor barrel = getOneIntersectingObject(Barrel.class);
        if(barrel != null) {
            setRotation(getRotation()+45);
            Vector v = getMovement();
            v.setDirection(getRotation());
            move();
            
            //if we have hit a barrel, make all the barrels in the world 
            //move down by 5 pixels
            java.util.List<Barrel> barrels;
            barrels = getWorld().getObjects(Barrel.class);
            
            //getWorld().removeObjects(getWorld().getObjects(Barrel.class));
            //for-each loop used to go through collection and move each 
            //barrel down
            //Syntax:  for(TypeOfThingInCollection variableName: nameOfCollection)
            for(Barrel b: barrels) {
                b.setLocation(b.getX(), b.getY()+5);
                //b.setImage("flower2.png");
            }
        }
    }
}
